procedure TMainForm.StepperTimer(Sender: TObject);
var Cmd:TCommand;
    i,v:integer; s:string;
const hex:array[0..15]of char='0123456789ABCDEF';
begin
  if PC>High(Prog.Code) then begin
    TerminateProg(true);
    exit;
  end;
  Cmd:=Prog.Code[PC]; inc(PC);
  Variables[#96]:=integer(MathError);
  with Cmd do case Cmd of
    CMD_LET:begin
              LastLet:=Evaluate(Expr);
              Variables[Op]:=LastLet;
              LastLetError:=MathError;
              HaveLastLet:=true;
            end;
    CMD_WRITE,CMD_WRITELN:begin             
                            MathError:=false;   
                            if Expr=nil then s:=Str
                            else if Op=#0 then begin
                              if Ref2<0 then begin
                                s:=FloatToStr(Evaluate(Expr));
                                i:=Ref1-length(s);
                                if i>0 then s:=StringOfChar(#32,i)+s;
                              end else
                                system.str(Evaluate(Expr):Ref1:Ref2,s);
                            end else begin
                              s:='';
                              v:=trunc(Evaluate(Expr));
                              if v=0 then s:='0' else
                                while v<>0 do begin
                                  s:=hex[v AND ((1 SHL byte(Op))-1)]+s;
                                  v:=v SHR byte(Op);
                                end;
                              if Ref1>0 then begin
                                i:=Ref1-length(s);
                                     if i>0 then s:=StringOfChar(#48,i)+s
                                else if i<0 then s:=copy(s,1-i,32);
                              end;  
                            end;
                            if not MathError then WriteBuf:=WriteBuf+s;
                            if Cmd=CMD_WRITELN then begin
                              AddLine(COUTPUT,WriteBuf);
                              WriteBuf:='';
                            end;
                          end;
    CMD_INPUT:begin
                InputTo:=Op;
                Stepper.Enabled:=false;
              end;
    CMD_GOTO:PC:=Ref1;
    CMD_IF:if Evaluate(Expr)=0.0 then PC:=Ref1;
    CMD_IF_GOTO:if Evaluate(Expr)<>0.0 then PC:=Ref1;
    CMD_SKIP:if Evaluate(Expr)<>0.0 then inc(PC);
    CMD_EXIT:begin
               AddLine(CERROR,'script aborted with EXIT');
               TerminateProg(true);
             end;
  end;
end;

